BORG 1.7.4
----------
Spanish (Argentina) Translation
Feature - add search in memo text
Feature - [3039608] Single pop-up window for multiple reminders
Feature - [3059547] Add Repeat Until as a Recurrence option
Feature [2945673] - add back start to system tray feature
Feature - option to filter closed tasks in project/task tree
Feature - option to filter closed tasks in project task list
Feature [2960249] - option to hide status and task number in task tree display
Feature - automatically detect a few more Look and Feels
Feature [2945434] add option to show date in tray icon
Feature [2985309] Single click activate, double click add appointment

Bug - Make Daylight Savings Time Change entries non-clickable
Bug - Fix import bug that messes up links. Also speed up import.
Bug - change color chooser buttons so that color is always shown. Was lost for some look and feels.
Bug [2934430] - add buttons to increase/decrease the size of the non-timed area for day and week views.
Bug - make todo table react to changes in user colors preference
Bug [2985307] ToDo list always appears at startup

Other - Move reports and GANTT chart out of BORG. Create an unsupported plugins project
to contain the reports, GANNT, and the old Ical import.

BORG 1.7.3
----------------
Feature [2893839] Add optional encryption for Memos and Appointments
Feature [2913708] extend search to cover all types
Feature - encrypt stored email password
Feature - allow user to provide their own reminder sound
Feature - set a default db on start up for new install. Do not prompt for DB options.

Change - Set default JGoodies theme to Experience Blue
Change - Hide report items if report libs not available
Change - Hide Gantt buttons if JFreechart not available
Change - Move UI logic out of Borg class. Move UI logic out of non-Swing thread.
Change - improve font options screen
Change - split up OptionsView class into smaller modules

[Bugs-2897010] Appt drag on month view works wrong if week starts with monday - only if first day of month is a sunday
Bug - Links to Borg Objects not deleted when target is deleted
Bug - Linked Memos do not open properly
Bug - Splash screen text is editable
Bug - NPE if popup timer goes off during shutdown after db is closed
Bug - Missing scrollbar in Appointment Panel
Bug - task filter missing on task list screen
Bug - appt boxes do not show strike-through text

BORG 1.7.2 - Developer Release
-----------------------------------
** Feature [2846844] Code Cleanup and Javadoc **
** The entire code base was cleaned up, refactored, and documented in this release.
** Thousands of lines of obsolete code have been removed.
** The UI code was rewritten to remove almost all of the IDE-generated code.

Feature [2769671] Add an address book search  
Feature [2852664] support TLS for SMTP (for gmail)
Feature [2876229] rewrite XML import/export to use JAXB
Feature [2876230] improve week/day view
Feature [2876231] add quick-note menu option
Feature [2876232] put the 3 task tabs under a single main tab
Feature [2876242] Remove Palm sync Support
Bug Fix [2876233] cleanup the translations - remove unused strings
Bug Fix [2876234] tab close/undock icons do not highlight
Bug Fix [2876236] clean up the online help
Bug Fix [2876237] popups sometimes continue after appts changed or deleted
Bug Fix [2876238] when deleting multiple addresses - the wrong ones are deleted
Bug Fix [2876240] fix calendar view tooltip
Bug Fix [2745960] pop up reminder non-functional at large-minute settings 
Bug Fix [1728135] No Popups--- Date Doesn't Advance
Bug Fix [1693757] Category name size not checked

** BORG 1.7.2 now requires Java 6.
  
BORG 1.7.1
----------
Feature [2648806] add an undo feature
Feature [2234537] add quick-todo option to calendar context menus
Feature [2221223] backup to ZIP file
Feature [2216864] add task list to project view
Feature [2626455] add option to change SMTP port
Feature [2628166] highlight tab icons on mouse-over
Feature [2628187] highlight the link tab on tasks if links are present
Bug Fix [2465525] RunSQL missing commit
Bug Fix [1988106] Overlapping widgets on recurrence panel
Bug Fix [2628138] don't send empty reminder email  


Simple BORG 1.7
-----------------
Feature 2198214  Create Simple BORG 
Feature 2198199  Add option to hide strike-through items
Feature 2198196  Add tray icon option to hide all reminders
Feature 2198193  Make sure quick todos take fields from the default appt
Feature 2198191  display count of vacation days per year
Feature 2198189  Enhance New appointment box
Feature 2198182  Add ability to search for items with links
Feature 2198179  Makes tasks/projects/subtasks editable from calendar UIs
Feature 2198173  Convert all code to use Generics
Feature 2198172  Remove ical/vcal support
Feature 2198165  Remove multi-user features
Feature 2198160  Use Java 6 system tray
Feature 2198157  Upgrade to Java 6  

Remove about 1/3 of the code and lots of non-core features.
Removed: multi-user, remote server, local files db, ical/vcal, and many rarely-used smaller features


Version 1.6.1 Final
-------------------
Feature [1904725]  mark todos as done from reminder popup
Feature [1903141]  Add marker on calendar if appt has links  
Feature [1871712]  Show past non-timed todo reminders
Bug Fix [1959692]  can't drag appt from non-timed to timed  
Bug Fix [1951636]  cant change save a task after first entered
Bug Fix [1933587]  deleted repeats show up in todo list and popups
Bug Fix [1909656]  month and year view missing 1st
Bug Fix [1886138]  ClassCastException when savong changed subtask
Bug Fix [1873225]  Add New from Day/Week view broken in 1.6.1 b3

Version 1.6.1 Beta 3
--------------------
Feature [1851556] add links/attachments
Feature [1820023] Links and hyperlinks
Feature [1595707] Add Address Book linking with dates
Feature [1653120] Add "Year View" tab/display
Feature [1671535] Date/time-stamp for Memos
Feature [1856643] improve SQL output 
Bug Fix [1856661] Program loses track of window size after maximize
Bug Fix [1856590] Run SQL runs too slow 
Bug Fix [1855501] Time Zone Problem

Version 1.6.1 beta 2
--------------------
Feature [1833863] allow dragging of appts in the month view  
Feature [1842095] add sub projects
Feature [1833864] allow dragging of appts outside of grid in day/week views
Feature [1834235] import/export of preferences  
Feature [1834573] automatic backup
Feature [1841894] display task and subtask duration column
Feature [1841893] change subtask creation date to start date
Bug Fix [1844200] Todo marker icon does not scale
Bug Fix [1844197] Text todo marker functionality accidentally removed
Bug Fix [1844194] day and week print is meesed up in 1.6.1 beta  
Bug Fix [1833869] user colors not used in new views
Bug Fix [1834857] error when emailing meeting notice 
Bug Fix [1619520] today marker color doesn't update 
Bug Fix [1842126] Task import bug
Bug Fix [1840005] Palm Conduits will not work with Hotsync 6
Bug Fix [1839373] Project status / localized value  
  

Version 1.6.1 Beta
------------------
Feature [1830421] new month view  
Feature [1826911] add a toolbar  
Feature [1778929] GANTT Charts
Feature [1825699] make some of the windows dockable 
Feature [1826487] add a tree based project browser
Feature [1829289] add todo marker to day and week views 
Feature [1827264] allow appts to be dragged between days on the week view      
Feature [1730886] add automatic db update for hsqldb 
Feature [1730718] support private memos
Feature [1799708] memo: warn on unsaved changes  
Feature [1716211] allow undated tasks
Feature [1824596] send email errors to a window  
Feature [1829365] obsolete old features 
Feature [1831526] todos incorrectly marked as done in month print   
Bug Fix [1781575] reminder popups show for deleted appts  
Bug Fix [1777793] do not validate dates of closed tasks/subtasks
Bug Fix [1746887] null pointer error when chging task due date
Bug Fix [1738531] task state editor hangs
Bug Fix [1730918] private todo's are not private on the Palm
Bug Fix [1719016] some files missing from install
Bug Fix [1714949] system tray errors in Linux
Bug Fix [1787412] Palm Appt Conduit Performance bug  
Refactor code into a single Eclipse Project (except for palm and servlet). Reorganize Packages.

Version 1.6
-----------
Add Portuguese (Brazilian) translation
Feature [1664278] Add "copy to date" option in Appointment Editor
Feature [1663823] Add day-of-week name to header of "Day" view
Feature [1656975] Options for "ToDo" icon?
Feature [1651947] Tasklist to OpenOffice Calc Export
Feature [1628049] memo to txt combined with txt2tags
Bug Fix [1704593] repeating todo bug 
Bug Fix [1690078] conditional formating is lost on columns 
Bug Fix [1690074] project creation dates do not check overlaps
Bug Fix [1668450] Partial character crop in name display of Address Book
Bug Fix [1666260] Remote Mysql server connection problem
Bug Fix [1657333] Todo View does not refresh when subtask closed
Bug Fix [1656972] No "Project" or "Tasks" display w/ some "Look/Feel" options 
Bug Fix [1655548] java.lang.Exception: Error: No initial state found for task
Bug Fix [1654751] NullPointerException from TodoView.java

Version 1.6 beta 2
------------------
Feature [1646015] enhance remote db to support tasks
Feature [1645758] use project values to initialize new task
Feature [1645750] allow task navigation and close from todo list
Feature [1645720] add projects to calendar
Feature [1644941] display subtasks on todo list
Feature [1651552] improve look of week/day view
Feature [1644928] add option to turn off task numbers in cal & todo list
Bug Fix [1646013] project import fails
Bug Fix [1633184] Error with MySQL 4.0
Bug Fix [1629517] can close task with open subtasks
Bug Fix [1629514] save task incorrectly detects date change


Version 1.6 beta 1
------------------
Feature [1109652] - Redesign Subtasks in Task Tracker to allow unlimited subtasks per task, each with its own due date
Feature [1109652] - Add Projects. A Project contains a collection of related Tasks.
Feature [1593551] - Add a Task Log to record Task status changes
Feature [1617531] - Add Simple Plain-Text memos, compatible with Palm-Desktop
Feature [1617531] - Add Palm Hot-Sync conduit for the new memos
Feature [1618416] - Move the Task Tracker into the main window as 2 new tabs - Projects and Tasks
Feature [1622984] - Make HSQLDB the default and deprecate Local Files
Feature [1358885] - Separate the appointment title and description in the editor
Feature [1616972] - Update the date chooser widget (which will also fix some bugs caused by the prior one)
Feature [1592065] - Support Skipped Repeats on the Palm
Feature [1590836] - Store all BORG appt fields on the Palm to prevent editing appts on the Palm from clearing certain fields
Bug Fix [1619741] - fix up the default colors, which were ugly and hard to see at times.
Bug Fix [1619498] - fix up the behaviour of tables and add row striping
Bug Fix [1600804] - sort elapsed time numerically
Bug Fix [1590982] - prevent changes to a repeating appt or todo from resetting the list of skipped days and done occurrences when possible
Bug Fix [1590834] - Palm sync should not lose the appt color

*** Deprecated the Local Files Database. HSQLDB is now the default ***

Version 1.5.2
-------------
HSQLDB Standalone Database Support
Allow navigation and access to the appt editor from day and week views
Combine Month/Day/Week views into one tabbed window
Allow graphical appt editing from the day and week views
Add full appt text on mouse-over to day and week views
Add half-hourly reminder popups for the day's untimed todos
Make fonts in printouts, day, and week view tunable
Make the popup reminder times tunable
Add option to shutoff system tray
Upgrade iCal libraries

Version 1.5.1.2
---------------
Show as many days from prior and next month as will fit in the current month view
Socket Interface - available commands: shutdown, sync, open
Updated German Translation - (also in 1.5.1.1)
Track Closed Date for Tasks
Track Elapsed Time for Tasks
Timed Individual Reminder Emails for Appointments 

Version 1.5.1
-------------
Ability to open multiple shared (public) calendars when using remote server
Keyboard Shortcuts
Fulltext tooltips when hovering over days in the month view
Todo and Appt quick change date and move to next date actions
Todo and Appt List right click context menus
Add date chooser for birthdays
Flemish (Dutch Belgian) Translation by Rudy Defrene < sat2freak@users.sourceforge.net>
Repeat by user-selected days of the week
Tomcat-based data server
Improved Search
Bulk Delete and Change Category
Fix some major Palm Sync Bugs
Add PRI column to Task List View
Add word-wrap to week view
Support both case sensitive and insensitive filtering/searching
Upgrade to JGoodies Looks 1.3.2
SMTP authentication support
MYSQL 5.0 compatible

Version 1.5
-----------
Import iCal into a particular category (1.5 final only)
Delete Category including appts and tasks (1.5 final only)
Palm Synchronization Conduits
Improved Popup reminders with user tunable popup times per appointment
Add date chooser to task GUI
Share categories between appointments and tasks.
Change to use category pull-down menu on task editor
Allow GIF images to mark todos in calendar
Simplified Chinese Translation
Dutch Translation
Remove Logging feature
Switch to JDIC for Windows and Linux Tray Icon Support
Ability to send reminder email on demand for any day
Option to show repeat occurrence number
Multi-user DB auto-sync
Tunable reminder email time
Option not to truncate appointment text at one line
Email to multiple addresses
Tunable line-spacing in month view
Bug fixes

Version 1.4.2
-------------
Polish Translation from Rafa? Gawro?ski
User tunable colors for the month view and todo list
Export to vCalendar 1.0 (.vcs) format (used by Palm Desktop)
Save Address or Task information as HTML using XSLT
Improved Todo GUI
Highlight todo's on the month view
Show done todo's with strike-through
Add day navigation from appointment editor
Other miscellaneous GUI improvements
Option to export iCal in UTC (for outlook)
Repeat every N days
Bug fixes

Version 1.4 patch 1 (1.4.1)
---------------------------
A GUI to edit the tracker's task types and states
Screens will remember the size and position set by the user
Support large numbers of categories (>100)
Option to show day of year numbers
Bug Fixes

Version 1.4 final
--------------------
Italian Translation from Piero Trono http://php-multishop.com tropic@users.sourceforge.net
Add Bulk Delete from Search Results Menu
Add a new Help System based on JavaHelp
Ability to save default values in the appt editor
Repeat by Mon-Wed-Fri and Tues-Thurs
Improved week view layout that handles overlapping events
Day View
Remove trayicon classes from borg.jar and bundle in lib dir instead
Add Options option to the trayicon
Add better MySQL support to make it much simpler to use MySQL
Bug Fixes

Version 1.4 beta
---------------------
bundle the jgoodies look and feels with the product
import/export iCal format
new type of monthly repeat by week/day of week
jump from search and todo list to appt editor
refactoring of the model and database code
improvements to reduce volume of JDBC activity between client and db
Ability to run as a demo applet ("sandboxed mode")
add "apply" button for options - no more immediate apply
bug fixes

Version 1.3.2
---------------------
Use color when sorting appts
Add -trayname option
Export/Import to URL
Allow multiple BORGs to open and share the same database file
German Translation
Eliminate remaining US date formats
Add Week Numbers
bug fixes

Version 1.3.1 
----------------------------------
- ADD categories to Todo List
- ADD options to view README and CHANGES files
- redo the appointment editor to have an appointment list showing all of a day's appts.
  allow the user to select any appt on the list to edit.
- allow full-blown font selection for the default font, appointment font, and preview font
- Reorganize the code into packages. Refactor most of the code, except for NetBeans generated code.
- Support the full Print Option Dialog provided by Java, which includes options for paper size, page orientation, copies, etc...
- Support printing of 1-12 months at a time. Most printer drivers can then provide 2-sided printing and 2-up printing.
- Add a birthday field to the address book. Use this field to include birthdays on the calendar, along with age.
- Support unlimited repeats for appointments with a new checkbox on the appointment editor
- add 2 more repeat frequencies
- make the preferences window smaller by using tabs
- make the popup reminder functionality tunable from the preferences window
- make the splash screen optional
- bug fixes: fix some window layout problems where windows would display too narrow.
             fix bug that sometimes messed up the main window look and feel whenever the options menu was opened.
             fix character encoding problems - make database and XML files UTF-8
             fix the first/last name problem in the address book
             fix appointment editor bug when repeat freq does not match times - bad db record is stored

             

Version 1.3 
-----------
- contents of 1.3 beta 1 & 2
- Spanish Translation
- ability to change locale from the options screen
- eliminate lock files/switch to java.nio locking

Version 1.3 beta 2
--------------------------------
- appointment categories/virtual calendars
- resource files for internationalization
- more tray icon menu options
- allow XML import without KEYs
- todo quick-add
- ability to move appointments from one date to another
- ability to change the type of a task in progress
- bug fixes

Version 1.3 beta 1
--------------------------------
- Add Jdbc database layer - experimental
- Add Address Book
- Add Task Categories

Version 1.2
--------------------------------
- Add User-Defined Print Logo to month view
- Add import from XML and improve export to XML
- Standardize Date format in the database to make it portable
  across incompatible locales
- Add Repair tool to MDB
- Add support for Windows systray
- Add Canadian Holidays
- Add word wrap option for month view and month print
- Add navigation menu
- Add task save button
- Bug fixes

Version 1.1 beta
--------------------------------
Week View and Print
Appointment Durations
Better support for non-scheduled appts from appt editor
Major code cleanup. Rewrite of much of the class model.
  - Redo all classes. Redo Model, View, Controller
  - Create new BeanDB Database object to use instead of SMDB
  - BeanDB will use a schema defined in XML
  - a class generator will also use the schema to generate Bean classes at
    build time
  - BeanDB will only export the generated Bean classes to the outside world
  - the generated classes will be Appointment and Task
Allow Database dir switch without program restart

Version 1.0
-----------
- First Day of Week = Monday
- 24 hour time format
- bug fix for missing day contributed by Mark Wrangham (ptigga@users.sourceforge.net)
- allow change of LookAndFeel to any installed LookAndFeel or any in
  classpath.
- allow system subtasks to be tunable
- fix bug where 0:00 showed up as the time for a non-scheduled appt

Version 0.9.4
-------------
- Print Preview
- Background color added to color print
- Auto Update check - optional feature to periodically check - BORG website for latest release number so users do not have to check for new releases.
- Preview of Todos and Tasks on the main window
- some code cleanup. One or two bug fixes.

Version 0.9.3
-------------
added autostart feature
made task types and states tunable - a sizable new feature
improved help screen
added comments, comments, and more comments to the source
fixed 2 popup bugs - see bug tracker for info

Version 0.9.2
-------------
- Add 5 user tunable checkboxes per task to track subtasks
- Fix bug where beeping popup would continue beeping after the window was closed.

Version 0.9.1
-------------
- Auto population of most US holidays
- XML export and logging
- Audio notification of imminent appointments

Version 0.9
-----------
Initial Release on SourceForge
Removed all non-GPL code

Ancient History
---------------
8/2001 - Initial Java version
7/1994 - Initial Tcl/Tk/C++ version
Early 90's - Original X11 Version, C++/Xaw

Original Copyright (no longer valid)
------------------
This program is not to be in the possession of anyone except Michael Berger.
Do not even think of reading the rest of this sentence without explicit 
permission from Michael Berger, unless you are a good friend of Michael 
Berger, or someone who has provided free food for Michael B. Berger.
